package de.marstra.dvo.obfuscator.analysis;

import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.jf.dexlib2.iface.Method;

@AllArgsConstructor
@EqualsAndHashCode
public class DexMethod extends DexItem {
    @Getter
    @Setter
    private Method method;
    @Getter
    private final DexClass dexClass;

    @Override
    public final <RetType, Param> RetType accept(final AnalysisVisitor<RetType, Param> av, Param p) {
        return av.visit(this, p);
    }
}
