package de.marstra.dvo.obfuscator.obfuscator;

import de.marstra.dvo.obfuscator.util.GenericMethodReference;
import org.junit.Test;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;

public class GenericMethodReferenceTest {
    @Test
    public void sigParse() {
        GenericMethodReference gmr = new GenericMethodReference("LTest;->test(I[[[Ljava/lang/Object;JZBDLjava/lang/Integer;)Ljava/lang/Object;");
        assertEquals(gmr.getDefiningClass(), "LTest;");
        assertEquals(gmr.getName(), "test");
        assertEquals(gmr.getReturnType(), "Ljava/lang/Object;");
        assertArrayEquals(new String[]{"I", "[[[Ljava/lang/Object;", "J", "Z", "B", "D", "Ljava/lang/Integer;"}, gmr.getParameterTypes());
    }
}