package de.marstra.dvo.obfuscator.obfuscator;

import org.intellij.lang.annotations.Language;
import org.junit.Test;

public class MiscTest {
    // Method com.anoshenko.android.mahjongg.Utils->Deal([I)V from app https://f-droid.org/en/packages/com.anoshenko.android.mahjongg/
    // This method triggered an ArrayOutOfBoundsException caused by wrong implementation of RSUB_INT_LIT
    @Test
    public void testDeal() {
        @Language("java") String code = "" +
                "import java.util.Random;\n" +
                "public class Test {\n" +
                "   private static final int DIE_COUNT = 36;\n" +
                "   static void Deal(int[] result) {\n" +
                "        int[] work = new int[DIE_COUNT * 4];\n" +
                "        int i, k, n = 0;\n" +
                "        Random r = new Random(1);\n" +
                "        for (i = 0; i < DIE_COUNT; i++)\n" +
                "            for (k = 0; k < 4; k++) {\n" +
                "                work[n] = i;\n" +
                "                n++;\n" +
                "            }\n" +
                "        n = DIE_COUNT * 4;\n" +
                "        while (n > 1) {\n" +
                "            k = r.nextInt(n);\n" +
                "            if (k < n) {\n" +
                "                result[DIE_COUNT * 4 - n] = work[k];\n" +
                "                for (i = k + 1; i < work.length; i++)\n" +
                "                    work[i - 1] = work[i];\n" +
                "                n--;\n" +
                "            }\n" +
                "        }\n" +
                "        result[DIE_COUNT * 4 - 1] = work[0];\n" +
                "    }" +
                "    public static Object test(Object[] args){\n" +
                "        int[] array = new int[DIE_COUNT * 4];\n" +
                "        Deal(array);\n" +
                "        return array;\n" +
                "    }\n" +
                "}";
        new InterpreterTestCase(code, "LTest;->Deal([I)V").run();
    }

}
