#!/usr/bin/env bash

set -e

EVADIR="$(dirname "$(readlink -f "$0")")"

CP=$(mvn -f $EVADIR --batch-mode dependency:build-classpath | sed "/.*\[INFO\].*/d")

mvn -f $EVADIR/.. install -DskipTests

java -cp $CP:$EVADIR/target/classes de.marstra.dvo.evaluation.Main $@
