package de.marstra.dvo.obfuscator.analysis;

public interface AnalysisVisitor<RetType, Param> {
    RetType visit(DexPackage dexPackage, Param param);

    RetType visit(DexClass dexClass, Param param);

    RetType visit(DexMethod dexMethod, Param param);
}
