package de.marstra.dvo.obfuscator.insn;

import com.squareup.javapoet.CodeBlock;

import static de.marstra.dvo.obfuscator.insn.InstructionType.GOTO;

public class Goto extends OffsetInstruction {
    public Goto(int codeOffset) {
        super(codeOffset, GOTO, GOTO);
    }

    public static void generateCase(CodeBlock.Builder builder, InstructionType type) {
        builder.addStatement("pc = " + readInt())
                .addStatement("continue");
    }
}
