package interpreter;

import org.junit.Test;

import java.util.Random;

import static org.junit.Assert.*;

public class InterpreterNumberTest {

    @Test
    public void floatNumbers(){
        float f = new Random().nextFloat();
        InterpreterNumber in = new InterpreterNumber(f);
        assertEquals(f, in.floatValue(), 0);
    }

    @Test
    public void doubleNumbers(){
        double d = new Random().nextDouble();
        InterpreterNumber in = new InterpreterNumber(d);
        assertEquals(d, in.doubleValue(), 0);
    }
}